EDIT - bug #9520

Taxonnode parent merge cascade leads to non-transactional behavior
03/05/2021 06:20 PM - Andreas Mdller
Priority: Highest Due date:
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.21

Severity: critical Found in Version:

Description

If a taxon node is changed and saved the update result also contains its parent and also grandparents up to the classification. This
can be seen in the session view of the TaxEditor When saving again all these objects are also merged.

This is not only a performance issue for deeper classifications but it also leads to a situation that if the parent was edited and saved
in the meanwhile this editing gets lost because the parent state of the child is saved afterwards.

This behavior can be reproduced by:

Open parent and child

Change child (e.g. publish flag) and save
Change parent (e.g. publish flag) and save
Change child again and save

o o o o

Reopen parent => it has the state from before the change

This is critical.

NOTE: Before closing: think about removing SaveOrUpdateEntityListener. It is currently not used anymore.

Associated revisions

Revision 76512e45 - 03/05/2021 06:22 PM - Andreas Miiller

ref #9520 try to remove cascade from TaxonNode.parent

Revision 117f7bd2 - 03/05/2021 09:39 PM - Andreas Miiller

ref #9520 fix TaxonNodeNaturalComparator for nodes without treeindex (should not really happen)

Revision fd734dc9 - 03/05/2021 09:41 PM - Andreas Miiller

ref #9520 fix ClassificationServicelmpl und TaxonServicelmplTest for non-cascading parent node

Revision 16076af1 - 03/05/2021 09:43 PM - Andreas Miiller

ref #9520 move treelndex update to CdmPreDataChangelListener as SaveOrUpdateEntityListener is not always fired

(only when object is explicitly saved or updated)

Revision 27b9e776 - 03/05/2021 09:44 PM - Andreas Miiller

ref #9520 fix TaxonNodeServicelmplTest after treelndex is now correctly triggered

Revision c5ec3f4d - 03/05/2021 10:29 PM - Andreas Miiller

ref #9520 fix FeatureNodeServicelmplTest which had incorrect test data

Revision ea17bbe6 - 03/05/2021 11:39 PM - Andreas Miiller
ref #9520 try to fix failing addTaxonNodeCascadeProblem by persisting child first

History
#1 - 03/05/2021 11:48 PM - Andreas Miiller

- Status changed from New to Resolved

- Assignee changed from Andreas Muiller to Katja Luther
- Priority changed from New to Highest

- % Done changed from 0 to 50

This needs intensive reviewing as | removed cascading taxon node to parent.
| tested already that the problem itself is solved. | tested the steps from the description and now the new state remains after the child was saved.

#2 - 03/06/2021 11:05 AM - Andreas Miiller

- Description updated

#3 - 03/10/2021 12:25 PM - Katja Luther
- Status changed from Resolved to Closed
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 50 to 100

Seems to work as expected.
